<?php

namespace Model;

use \Nette\Datetime;

/**
 * Provádí operace nad databázovou tabulkou.
 */
abstract class DataModel extends Model
{
	/** returns array, composition depends on parameters
	* @param ActiveRow row of strategy or prediction (must have column 'filename')
	* @param int position of column in csv (if we want only values (only values = TRUE))
	* @param bool if we want only values
	* @param int column in which is stored date
	* @param int column in which is stored time
	* @return array
	*/
	public function csvToArray($activeRow, $column, $onlyValues = FALSE, $date = NULL, $time = NULL)
	{
		$column = $column - 1;
		$delimiter = ',';
		if(!file_exists($activeRow['filename']) || !is_readable($activeRow['filename']))
	        return FALSE;

	    $header = NULL;

	    $values = array();
	    if (!$onlyValues){
	    	$values[] = array('X', 'Y');
	    }
	    
    	if (($handle = fopen($activeRow['filename'], 'r')) !== FALSE){
	        while (($row = fgetcsv($handle, 1000, $delimiter)) !== FALSE)
	        {
	   			if ($onlyValues){
	   				$value = (float)$row[$column];
	   			} else {
	   				if ($date !== NULL && $time !== NULL){
	   					$datetime = DateTime::createFromFormat('Y-m-d H:i', str_replace('.', '-', $row[$date]) . ' ' . $row[$time]);
  						$value = array($datetime->format('d.m.Y H:i'), (float)$row[$column]);
	   				} else {
	   					if (!isset($i)) {
	   						$i = 0;
	   					}
  						$value = array($i++, (float)$row[$column]);
	   				}
	   			}

  				$values[] = $value;
	    	}
	    	fclose($handle);
		}

		//return $values;
		return json_encode($values);
	}

	//ECHO MEMORY USAGE
	function echo_memory_usage() { 
        $mem_usage = memory_get_usage(true); 
        
        if ($mem_usage < 1024) 
            echo $mem_usage." bytes"; 
        elseif ($mem_usage < 1048576) 
            echo round($mem_usage/1024,2)." kilobytes"; 
        else 
            echo round($mem_usage/1048576,2)." megabytes"; 
            
        echo "<br/>"; 
    } 
}