<?php

namespace Model;

/**
 * Provádí operace nad databázovou tabulkou.
 */
abstract class Model extends BaseModel
{
	
	public function findBetween(Date $from, Date $to, $collumn = 'date')
	{
		return $this->getTable()->where($collumn . ' BETWEEN ? AND ?', array($from, $to));
	}
	
	public function add($values)
	{
		return $this->getTable()->insert($values);
	}

	public function delete($id)
	{
		$this->findById($id)->delete();
	}
	
	public function update($id, $values)
	{
		return $this->findById($id)->update($values);
	}
	
	public function findByUser($userId)
	{
		return $this->findBy(array('user_id' => $userId));
	}

}