<?php

use Nette\Security as NS;

class Authenticator extends Nette\Object implements NS\IAuthenticator
{
    private $userModel;

    function __construct(Model\UserModel $userModel)
    {
        $this->userModel = $userModel;
    }

    function authenticate(array $credentials)
    {
        list($email, $password) = $credentials;
        $row = $this->userModel->findBy(array('email' => $email))->fetch();

        if (!$row) {
            throw new NS\AuthenticationException('The email is incorrect.', self::IDENTITY_NOT_FOUND);
        }

        if (!NS\Passwords::verify($password, $row->password)) {
            throw new NS\AuthenticationException('The password is incorrect.', self::INVALID_CREDENTIAL);
        }

        $arr = $row->toArray();
        unset($arr['password']);

        return new NS\Identity($row['id'], $row['role'], $arr);
    }
}