<?php

namespace Model\Indicators;


/**
 * Indikator CCI (commodity channel index)
 */
class CommodityChannelIndex
{
	public function getValues($indicator, $prices)
	{
		return trader_cci($prices['high'], $prices['low'], $prices['close'], $indicator->period);
		/*dump($indiValues);exit;
		$indiValues = array();
		foreach ($prices as $key => $values) {
			if ($key < $indicator->period){
				$indiValues[$key] = NULL;
			} else {
				$sumTP = 0;
				for ($i = $key-$indicator->period+1; $i <= $key; $i++){
					//Typical price
					$TP = ($prices[$i]['high'] + $prices[$i]['low'] + $prices[$i]['close']) / 3;
					//typical price sum
					$sumTP += $TP; 
				}
				//Simple Moving Average of Typical Prices
				$smaTP = $sumTP / $indicator->period;																																																										
				
				$sumD = 0;
				for ($i = $key-$indicator->period+1; $i <= $key; $i++){
					//Typical price
					$TP = ($prices[$i]['high'] + $prices[$i]['low'] + $prices[$i]['close']) / 3;
					$D = $TP - $smaTP;
					//typical price sum
					$sumD += abs($D); 
				}
				$TP = ($prices[$key]['high'] + $prices[$key]['low'] + $prices[$key]['close']) / 3;
				$smaD = $sumD / $indicator->period;

				$indiValues[$key] = ($TP-$smaTP)/($smaD*0.015);
			}
		}
		dump($indiValues);exit;

		return $indiValues;*/
	}

	public function test($indicator, $indicatorValues, $priceKey, $price)
	{
		switch ($indicator->rule){
			case 'CCI_entering_100':
				//CCI entering 100+ area
				if ($indicatorValues[$priceKey] > 100 && $indicatorValues[$priceKey-1] < 100){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'CCI_leaving_100':
				//CCI leaving 100+ area
				if ($indicatorValues[$priceKey] < 100 && $indicatorValues[$priceKey-1] > 100){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'CCI_entering_m100':
				//CCI entering 30- area
				if ($indicatorValues[$priceKey] < -100 && $indicatorValues[$priceKey-1] > -100){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'CCI_leaving_m100':
				//CCI leaving 30- area
				if ($indicatorValues[$priceKey] > -100 && $indicatorValues[$priceKey-1] < -100){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'CCI_over':
				//CCI > ?
				if ($indicatorValues[$priceKey] > $indicator->rule_value){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'CCI_under':
				//CCI < ?
				if ($indicatorValues[$priceKey] < $indicator->rule_value){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'CCI_equal':
				//CCI = ?
				if (($indicatorValues[$priceKey] < $indicator->rule_value && $indicatorValues[$priceKey-1] > $indicator->rule_value) || ($indicatorValues[$priceKey] > $indicator->rule_value && $indicatorValues[$priceKey-1] < $indicator->rule_value)){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			default:
				return FALSE;
		}
	}
}
