<?php

namespace Model\Indicators;


/**
 * Tabulka strategy_indicator
 */
class Indicator
{
	//DONE
	private $movingAverage;
	private $relativeStrengthIndex;
	private $commodityChannelIndex;
	private $parabolicSAR;
	private $doji;
	private $dojiStar;
	private $shootingStar;
	private $hammer;
	private $hangingMan;
	private $neuralNetwork;

	//TODO
	private $tradersDynamicIndex;


	public function __construct(MovingAverage $movingAverage, RelativeStrengthIndex $relativeStrengthIndex, CommodityChannelIndex $commodityChannelIndex, ParabolicSAR $parabolicSAR, Doji $doji, DojiStar $dojiStar, ShootingStar $shootingStar, Hammer $hammer, HangingMan $hangingMan, NeuralNetwork $neuralNetwork, TradersDynamicIndex $tradersDynamicIndex)
	{
		$this->movingAverage = $movingAverage;
		$this->relativeStrengthIndex = $relativeStrengthIndex;
		$this->commodityChannelIndex = $commodityChannelIndex;
		$this->parabolicSAR = $parabolicSAR;
		$this->doji = $doji;
		$this->dojiStar = $dojiStar;
		$this->shootingStar = $shootingStar;
		$this->hammer = $hammer;
		$this->hangingMan = $hangingMan;
		$this->neuralNetwork = $neuralNetwork;
		$this->tradersDynamicIndex = $tradersDynamicIndex;
	}
	
	public function getValues($indicator, $prices)
	{
		switch ($indicator->type){
			case 'ma':
				return $this->movingAverage->getValues($indicator, $prices);
			case 'rsi':
				return $this->relativeStrengthIndex->getValues($indicator, $prices);
			case 'cci':
				return $this->commodityChannelIndex->getValues($indicator, $prices);
			case 'sar':
				return $this->parabolicSAR->getValues($indicator, $prices);
			case 'doji':
				return $this->doji->getValues($indicator, $prices);	
			case 'doji_star':
				return $this->dojiStar->getValues($indicator, $prices);	
			case 'shooting_star':
				return $this->shootingStar->getValues($indicator, $prices);	
			case 'hammer':
				return $this->hammer->getValues($indicator, $prices);
			case 'hanging_man':
				return $this->hangingMan->getValues($indicator, $prices);
			case 'neural_network':
				return $this->neuralNetwork->getValues($indicator, $prices);
			case 'tdi':
				return $this->tradersDynamicIndex->getValues($indicator, $prices);
			default:
				return FALSE;
		}
	}

	public function test($indicator, $indicatorValues, $priceKey, $price, $type)
	{
		switch ($indicator->type){
			case 'ma':
				return $this->movingAverage->test($indicator, $indicatorValues, $priceKey, $price);
			case 'rsi':
				return $this->relativeStrengthIndex->test($indicator, $indicatorValues, $priceKey, $price);
			case 'cci':
				return $this->commodityChannelIndex->test($indicator, $indicatorValues, $priceKey, $price);
			case 'sar':
				return $this->parabolicSAR->test($indicator, $indicatorValues, $priceKey, $price);
			case 'doji':
				return $this->doji->test($indicator, $indicatorValues, $priceKey, $price);
			case 'doji_star':
				return $this->dojiStar->test($indicator, $indicatorValues, $priceKey, $price);
			case 'shooting_star':
				return $this->shootingStar->test($indicator, $indicatorValues, $priceKey, $price);
			case 'hammer':
				return $this->hammer->test($indicator, $indicatorValues, $priceKey, $price);
			case 'hanging_man':
				return $this->hangingMan->test($indicator, $indicatorValues, $priceKey, $price);
			case 'neural_network':
				return $this->neuralNetwork->test($indicator, $indicatorValues, $priceKey, $price, $type);
			default:
				return FALSE;
		}
	}
}
