<?php

namespace Model\Indicators;


/**
 * Indikator Moving Average (klouzavy prumer)
 */
class MovingAverage
{
	public function getValues($indicator, $prices)
	{
		switch ($indicator->type_indicator){
			case 'simple':
				$indiValues = trader_ma($prices['close'], $indicator->period,TRADER_MA_TYPE_SMA);
				/*$indiValues = array();
				foreach ($prices as $key => $values) {
					if ($key < $indicator->period){
						$indiValues[$values['date']] = NULL;
					} else {
						$sum = $values[$indicator->apply_to];
						for ($i = $key-$indicator->period+1; $i < $key; $i++){
							$sum += $prices[$i][$indicator->apply_to];
						}
						$indiValues[$values['date']] = $sum/$indicator->period;
					}
				}*/
				break;
			case 'exponential':
				$indiValues = trader_ma($prices['close'], $indicator->period,TRADER_MA_TYPE_EMA);
				/*foreach ($prices as $key => $values) {
					if ($key < $indicator->period){
						$indiValues[$values['date']] = NULL;
						$yesterdayEMA = $values[$indicator->apply_to];
					} else {
						$k = 2 / ($indicator->period + 1);
						$ema = $values[$indicator->apply_to] * $k + $yesterdayEMA * (1 - $k);
						$yesterdayEMA = $ema;
						$indiValues[$values['date']] = $ema;
					}
				}*/
				break;
			case 'smoothed':
				/*foreach ($prices as $key => $values) {
					if ($key < $indicator->period){
						$indiValues[$values['date']] = NULL;
						$lastSMMA = $values[$indicator->apply_to];
					} elseif ($key === $indicator->period){
						$sum = $values[$indicator->apply_to];
						for ($i = $key-$indicator->period+1; $i < $key; $i++){
							$sum += $prices[$i][$indicator->apply_to];
						}
						$lastSum = $sum;
						$lastSMMA = $sum/$indicator->period;
						$indiValues[$values['date']] = $lastSMMA;
					} else {
						$sum = $lastSum - $lastSMMA + $values[$indicator->apply_to];
						$lastSum = $sum;
						$lastSMMA = $sum / $indicator->period;
						$indiValues[$values['date']] = $lastSMMA;
					}
				}*/
				break;

			case 'weighted':
				$indiValues = trader_ma($prices['close'], $indicator->period,TRADER_MA_TYPE_WMA);
				/*foreach ($prices as $key => $values) {
					if ($key < $indicator->period){
						$indiValues[$values['date']] = NULL;
					} else {
						$sum = 0;
						$sumMultiplicator = 0;
						$multiplicator = $indicator->period;
						for ($i = $key; $i > $key-$indicator->period; $i--){
							$sum += $prices[$i][$indicator->apply_to] * $multiplicator;
							$sumMultiplicator += $multiplicator;
							$multiplicator = $multiplicator-1;
						}
						$indiValues[$values['date']] = $sum / $sumMultiplicator;
					}
				}*/
				break;
		}
		return $indiValues;
	}

	public function test($indicator, $indicatorValues, $priceKey, $price)
	{
		switch ($indicator->rule){
			case 'price_equal_MA':
				//price = MA
				if (isset($indicatorValues[$priceKey-1]) && (($price >= $indicatorValues[$priceKey] && $price <= $indicatorValues[$priceKey-1]) || ($price <= $indicatorValues[$priceKey] && $price >= $indicatorValues[$priceKey-1]))){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'price_over_MA':
				//price > MA
				if ($price > $indicatorValues[$priceKey]){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'price_under_MA':
				//price < MA
				if ($price < $indicatorValues[$priceKey]){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			default:
				return FALSE;
		}
	}
}
