<?php

namespace Model\Indicators;


/**
 * Indikator CCI (commodity channel index)
 */
class ParabolicSAR
{
	public function getValues($indicator, $prices)
	{
		return trader_sar($prices['high'], $prices['low'], $indicator->acceleration, $indicator->maximum);
	}

	public function test($indicator, $indicatorValues, $priceKey, $price)
	{
		switch ($indicator->rule){
			case 'SAR_up':
				//CCI entering 100+ area
				if ($indicatorValues[$priceKey] > $price){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'SAR_down':
				//CCI leaving 100+ area
				if ($indicatorValues[$priceKey] < $price){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			default:
				return FALSE;
		}
	}
}
