<?php

namespace Model\Indicators;


/**
 * Indikator RSI (relative strength index)
 */
class RelativeStrengthIndex
{
	public function getValues($indicator, $prices)
	{
		return trader_rsi($prices['close'], $indicator->period);	
		/*$indiValues = array();
		foreach ($prices as $key => $values) {
			if ($key < $indicator->period){
				$indiValues[$key] = NULL;
			} elseif ($key === $indicator->period) {
				$sumUp = 0;
				$sumDown = 0;
				for ($i = $key-$indicator->period+1; $i <= $key; $i++){
					$move = $prices[$i][$indicator->apply_to] - $prices[$i-1][$indicator->apply_to];
					if ($move > 0){
						$sumUp += $move;
					} else {
						$sumDown += abs($move);
					}
				}
				
				$avgUt = $sumUp / $indicator->period;
				$avgDt = $sumDown / $indicator->period;

				if ($avgDt == 0){
					$rsi = 0;
				} else {
					$rsi = 100 - (100 / (1 + $avgUt/$avgDt));
				}

				$indiValues[$key] = $rsi;
			} else {
				$avgUtYesterday = $avgUt;
				$avgDtYesterday = $avgDt;

				$sumUp = 0;
				$sumDown = 0;
				$move = $prices[$key][$indicator->apply_to] - $prices[$key-1][$indicator->apply_to]; 

				if ($move > 0){
					$sumUp += $move;
				} else {
					$sumDown += abs($move);
				}

				$avgUt = (($avgUtYesterday * ($indicator->period-1)) + ($sumUp / $indicator->period)) / $indicator->period;
				$avgDt = (($avgDtYesterday * ($indicator->period-1)) + ($sumDown / $indicator->period)) / $indicator->period;

				if ($avgDt == 0){
					$rsi = 0;
				} else {
					$rsi = 100 - (100 / (1 + $avgUt/$avgDt));
				}

				$indiValues[$key] = $rsi;
			}
		}

		return $indiValues;*/
	}

	public function test($indicator, $indicatorValues, $priceKey, $price)
	{
		switch ($indicator->rule){
			case 'RSI_entering_70':
				//RSI entering 70+ area
				if ($indicatorValues[$priceKey] > 70 && $indicatorValues[$priceKey-1] < 70){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'RSI_leaving_70':
				//RSI leaving 70+ area
				if ($indicatorValues[$priceKey] < 70 && $indicatorValues[$priceKey-1] > 70){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'RSI_entering_30':
				//RSI entering 30- area
				if ($indicatorValues[$priceKey] < 30 && $indicatorValues[$priceKey-1] > 30){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'RSI_leaving_30':
				//RSI leaving 30- area
				if ($indicatorValues[$priceKey] > 30 && $indicatorValues[$priceKey-1] < 30){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'RSI_over':
				//RSI > ?
				if ($indicatorValues[$priceKey] > $indicator->rule_value){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'RSI_under':
				//RSI < ?
				if ($indicatorValues[$priceKey] < $indicator->rule_value){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			case 'RSI_equal':
				//RSI = ?
				if (($indicatorValues[$priceKey] < $indicator->rule_value && $indicatorValues[$priceKey-1] > $indicator->rule_value) || ($indicatorValues[$priceKey] > $indicator->rule_value && $indicatorValues[$priceKey-1] < $indicator->rule_value)){
					return TRUE;
				} else {
					return FALSE;
				}
				break;
			default:
				return FALSE;
		}
	}
}
