<?php

namespace Model\Indicators;


/**
 * Indikator TDI (traders dynamic index)
 */
class TradersDynamicIndex
{
    protected $rsi;
    protected $stdDev;

    public function __construct(RelativeStrengthIndex $rsi, StandardDeviation $stdDev)
    {
        $this->rsi = $rsi;
        $this->stdDev = $stdDev;
    }

    public function getValues($indicator, $prices)
    {
        $indiValues = array();

        $rsiValues = $this->rsi->getValues($indicator, $prices);

        //price line SMA(2) of RSI(13) -> GREEN LINE
        $priceLineGreen = $this->SMA($rsiValues, 2);
        //signal line SMA(7) of RSI (13) -> RED LINE
        $signalLineRed = $this->SMA($rsiValues, 7);
        //midband SMA(34) of RSI (13) -> YELLOW LINE
        $baseLineYellow = $this->SMA($rsiValues, 34);
        //bollinger bands SMA(34) using 1.62 StdDev

        dump($baseLineYellow[221]['date']);
        dump($this->stdDev->getValues($baseLineYellow, 34, 221));
        exit;

        foreach ($prices as $key => $value) {
            


            $sumUp = 0;
            $sumDown = 0;
            if ($key < $period+1){
                $indiValues[$key] = NULL;
            } else {
                for ($i = $key-$period+1; $i <= $key; $i++){
                    $move = $prices[$i] - $prices[$i-1];
                    
                    if ($move > 0){
                        $sumUp += $move;
                    } else {
                        $sumDown += abs($move);
                    }
                }
                
                $avgUt = $sumUp / $period;
                $avgDt = $sumDown / $period;
                if ($avgDt == 0){
                    $rsi = 0;
                } else {
                    $rsi =  100 - (100 / (1 + ($avgUt/$avgDt)));
                }

                $indiValues[$key] = $rsi;
            }
        }

        return $indiValues;
    }

    public function SMA($values, $period)
    {
        $smaValues = array();

        foreach ($values as $key => $value) {
            $sum = 0;
            if ($value['value'] === NULL || $key < $period){
                $smaValues[$key]['value'] = NULL;
            } else {
                $sum = $value['value'];
                for ($i = $key-$period+1; $i < $key; $i++){
                    if ($values[$i]['value'] === NULL){
                        $sum = NULL;
                        break;
                    } else {
                        $sum += $values[$i]['value'];
                    }
                }

                if ($sum === NULL){
                    $smaValues[$key]['value'] = NULL;
                } else {
                    $smaValues[$key]['value'] = $sum/$period;
                }
                $smaValues[$key]['date'] = $value['date'];
            }
        }

        return $smaValues;
    }
}
