<?php

namespace Model;

use \Nette\Datetime;


/**
 * Tabulka strategy_data
 */
class StrategyDataModel extends DataModel
{

	public function csvToArrayTrader($strategy, $rowNumber = NULL)
	{
		$delimiter = ',';
		if(!file_exists($strategy['filename']) || !is_readable($strategy['filename']))
	        return FALSE;

	    $header = NULL;

	    $prices = array();

    	if (($handle = fopen($strategy['filename'], 'r')) !== FALSE){
	        while (($row = fgetcsv($handle, 1000, $delimiter)) !== FALSE)
	        {
	        	$prices['date'][] = str_replace('.', '-', $row[0]) .' '. str_replace('.', '-', $row[1]);
	        	$prices['open'][] = (float)$row[2];
	        	$prices['high'][] = (float)$row[3];
	        	$prices['low'][] = (float)$row[4];
	        	$prices['close'][] = (float)$row[5];
	    	}
	    	fclose($handle);
		}

		return $prices;
	}

	function getPrices($pricesType, $prices = NULL)
	{
		if ($prices === NULL){
			return $this->getTable()->fetchPairs('id', 'price_'.$pricesType);
		} else {
			$pricesArr = array();
			foreach ($prices as $key => $price) {
				$pricesArr[$key] = $price[$pricesType];
			}
			return $pricesArr;
		}
		
	}

	function getDate($key)
	{
		return $this->findById($key)->data_date;
	}

	function getPrecision($prices = NULL)
	{
		if ($prices === NULL){
			$row = $this->getTable()->fetch();
			if ($row !== NULL){
				if ($row->price !== NULL){
					return strlen(substr($row->price, strpos($row->price, '.')+1)); 
				} else {
					$precisions[] = strlen(substr($row->price_open, strpos($row->price_open, '.')+1)); 
					$precisions[] = strlen(substr($row->price_high, strpos($row->price_high, '.')+1));
					$precisions[] = strlen(substr($row->price_low, strpos($row->price_low, '.')+1));
					$precisions[] = strlen(substr($row->price_close, strpos($row->price_close, '.')+1));
					return max($precisions); 
				}
			} else {
				return 0;
			}
		} else {
			foreach ($prices as $key => $value) {
				foreach ($value as $key => $val) {
					$precisions[] = strlen(substr($val, strpos($val, '.')+1));	
				}
				$precision = max($precisions);
				unset($precisions);
				return $precision; 
			}
		}
		
	}

	//ECHO MEMORY USAGE
	function echo_memory_usage() { 
        $mem_usage = memory_get_usage(true); 
        
        if ($mem_usage < 1024) 
            echo $mem_usage." bytes"; 
        elseif ($mem_usage < 1048576) 
            echo round($mem_usage/1024,2)." kilobytes"; 
        else 
            echo round($mem_usage/1048576,2)." megabytes"; 
            
        echo "<br/>"; 
    } 

}