<?php

namespace Model;


/**
 * Tabulka strategy_indicator
 */
class StrategyIndicatorModel extends Model
{
	private $indicator;

	public function __construct(\Nette\Database\Context $db, Indicators\Indicator $indicator)
	{
		parent::__construct($db);
		$this->indicator = $indicator;
	}


	function insertIndicator($values)
	{
		switch ($values->type){
			case 'ma':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
					'period' => $values->MA_period,
					'type_indicator' => $values->MA_type,
					//'apply_to' => $values->MA_apply_to,
					'rule' => $values->MA_rule
				));
				break;
			case 'rsi':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
					'period' => $values->RSI_period,
					//'apply_to' => $values->RSI_apply_to,
					'rule' => $values->RSI_rule,
					'rule_value' => $values->RSI_rule_value
				));
				break;
			case 'cci':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
					'period' => $values->CCI_period,
					//'apply_to' => $values->CCI_apply_to,
					'rule' => $values->CCI_rule,
					'rule_value' => $values->CCI_rule_value
				));
				break;
			case 'sar':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
					'rule' => $values->SAR_rule,
					'acceleration' => $values->SAR_acceleration,
					'maximum' => $values->SAR_maximum
				));
				break;
			case 'doji':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
				));
				break;
			case 'doji_star':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
				));
				break;
			case 'shooting_star':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
				));
				break;
			case 'hammer':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
				));
				break;
			case 'hanging_man':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
				));
				break;
			case 'neural_network':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
					'prediction_settings_id' => $values->prediction_settings_id
				));
				break;
			case 'tdi':
				$row = $this->add(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type
				));
				break;
		}

		return $row;
	}

	function updateIndicator($values)
	{
		$indicator = $this->findById($values->id);
		switch ($values->type){
			case 'ma':
				$row = $indicator->update(array(
					'period' => $values->MA_period,
					'type_indicator' => $values->MA_type,
					//'apply_to' => $values->MA_apply_to,
					'rule' => $values->MA_rule
				));
				break;
			case 'rsi':
				$row = $indicator->update(array(
					'period' => $values->RSI_period,
					//'apply_to' => $values->RSI_apply_to,
					'rule' => $values->RSI_rule,
					'rule_value' => $values->RSI_rule_value
				));
				break;
			case 'cci':
				$row = $indicator->update(array(
					'period' => $values->CCI_period,
					//'apply_to' => $values->CCI_apply_to,
					'rule' => $values->CCI_rule,
					'rule_value' => $values->CCI_rule_value
				));
				break;
			case 'sar':
				$row = $indicator->update(array(
					'rule' => $values->SAR_rule,
					'acceleration' => $values->SAR_acceleration,
					'maximum' => $values->SAR_maximum
				));
				break;
			case 'doji':
				$row = $indicator->update(array(
				));
				break;
			case 'doji_star':
				$row = $indicator->update(array(
				));
				break;
			case 'shooting_star':
				$row = $indicator->update(array(
				));
				break;
			case 'hammer':
				$row = $indicator->update(array(
				));
				break;
			case 'hanging_man':
				$row = $indicator->update(array(
				));
				break;
			case 'neural_network':
				$row = $indicator->update(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
					'prediction_settings_id' => $values->prediction_settings_id
				));
				break;
			case 'tdi':
				$row = $indicator->update(array(
					'strategy_id' => $values->strategy_id,
					'type' => $values->type,
					'period' => 13,
					//'apply_to' => 'close'
				));
				break;
		}
		
		return $row;
	}

	public function getIndicatorsValues($indicators, $prices)
	{
		$indicatorsValues = array();
		foreach ($indicators as $key => $indicator){
			$indicatorsValues[$indicator->id] = $this->indicator->getValues($indicator, $prices);
		}
		
		return $indicatorsValues;
	}

	//type = BUY/SELL
	public function testRule($indicator, $indicatorValues, $priceKey, $price, $type)
	{
		return $this->indicator->test($indicator, $indicatorValues, $priceKey, $price, $type);
	}

}
